Debian Bug report logs - #683674
unblock: intel-microcode/1.20120606.6

Package: release.debian.org; Maintainer for release.debian.org is Debian Release Team <debian-release@lists.debian.org>;

Reported by: Henrique de Moraes Holschuh <hmh@debian.org>

Date: Thu, 2 Aug 2012 18:00:01 UTC

Owned by: Philipp Kern <pkern@debian.org>

Severity: normal

Done: Philipp Kern <pkern@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Release Team <debian-release@lists.debian.org>:
Bug#683674; Package release.debian.org. (Thu, 02 Aug 2012 18:00:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Henrique de Moraes Holschuh <hmh@debian.org>:
New Bug report received and forwarded. Copy sent to Debian Release Team <debian-release@lists.debian.org>. (Thu, 02 Aug 2012 18:00:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Henrique de Moraes Holschuh <hmh@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: unblock: intel-microcode/1.20120606.3
Date: Thu, 2 Aug 2012 14:57:35 -0300
Package: release.debian.org
Severity: normal
User: release.debian.org@packages.debian.org
Usertags: freeze-exception

Please unblock package intel-microcode

Relevant thread in debian-release:
http://lists.debian.org/debian-release/2012/07/msg01358.html

non-free stable and non-free wheezy are currently seriously lacking in
microcode support.  It is worth notice that nearly all recent Intel
_and_ AMD processors have been issued microcode updates, quite often
fixing relevant issues.

Stable lacks support for AMD system processors in userspace entirely,
and deprecated, half-useful support for Intel system processors.  Wheezy
currently has half-done userspace support for AMD system processors
[NOTE: now fixed by a freeze-exception being accepted] that requires
manual intervention to even work, and the same crap as stable for Intel
system processors.

These shortcomings have been fixed in non-free unstable for both Intel
and AMD microcode packages. [NOTE: amd64-microcode already unblocked]

A simple initramfs helper, along with documentation for those who
compile their own kernels and don't use an initramfs, was added to
amd64-microcode in unstable.  It manages to load processor microcode as
early as it is possible for the current Wheezy kernel.  The freeze
exception (unblock request) is in bug #681352, along with the debdiff.

This initramfs helper, which is also used on the updated intel-microcode
packages, is compatible with past and current kernels (tested in
2.6.32.x stable, 3.0.x stable, 3.2.x stable, 3.4.x stable), with the
soon-to-be-issued stable fix for the microcode core that accepts
requests only for the BSP (bootstrap processor) -- tested with 3.0 and
3.2 + fix backport, and with the upcoming per-system microcode sysfs ABI
that does away/deprecates the current per-core sysfs ABI.

Fixing intel-microcode [properly] was _much_ harder.  The ABI used by
microcode.ctl (/dev/cpu/microcode) has been deprecated in the kernel for
_years_ and will be removed sooner or later.  Switching to the sysfs /
firmware-loader based ABI requires new userspace, and in fact the new
intel-microcode package declares a "breaks: microcode.ctl" because the
very microcode data format required by the new ABI is unsupported by
microcode.ctl.

Since it is incredibly hard to deal with Intel microcode release
management, I had to actually write a heavy-duty tool (iucode-tool,
already accepted into Wheezy contrib) to even _know_ WTF I was pushing
to users at every new upstream microcode release.  I've been using it
for a while now.  This tool is also used to generate the
firmware-loader-compatible binary files split by processor
family-model-stepping required to update Intel processor microcode.

The same initrd helper used in amd64-microcode was also added to the
intel-microcode package.  The two packages CAN BE INSTALLED AT THE SAME
TIME in a system: the helpers do not collide, and they're smart enough
to notice the duplication, and attempt the microcode update only once
during boot.

Unfortunately, Intel ships a _LOT_ of microcode.  It's about 550KiB
uncompressed, split over a lot of files in /lib/firmware.  This would
waste a lot of initramfs space, so, should iucode-tool also be present
in the system at update-initramfs time, the intel-microcode package will
by default install to the initramfs only the microcode for the exact
system processors found (which typically means at most 32KiB worth of
uncompressed microcode :p).

Also, using iucode-tool, it was possible to restrict the number of
microcodes shipped in the intel-microcode binary package for the amd64
arch, by removing microcodes for very old processors that do not support
64-bit mode.  I also managed to salvage microcode for older processors
(Pentium II, Pentium III, Pentium-M, 1st and 2nd-gen Xeon) that Intel
did not ship anymore, but which still have Debian users.

This required a complete refactoring of the source package, and the
resulting debdiff for intel-microcode is, well, enourmous.  Mostly
because the *source* package now ships every Intel microcode ".dat" file
to date (each one is ~1.5MiB in size), in order to find the relevant
microcodes for older processors.  To keep the source package
_compressed_ size under control, I switched to XZ compression, and the
compressed source package is still < 1MiB.

The packages in unstable are well tested, and I'd really appreciate if
the Wheezy release managers would grant freeze exceptions for
amd64-microcode and intel-microcode.

diffstats for the intel-microcode update are below.
See explanation  above for why it is so big.

 b/.gitignore                               |    3 
 b/Makefile                                 |   96 
 b/cpu-signatures.txt                       |   98 
 b/debian/README.Debian                     |  131 
 b/debian/README.source                     |  127 
 b/debian/changelog                         |   70 
 b/debian/compat                            |    2 
 b/debian/control                           |   36 
 b/debian/diff-latest-pack.sh               |   25 
 b/debian/initramfs.hook                    |   90 
 b/debian/initramfs.init-premount           |   55 
 b/debian/intel-microcode.NEWS              |   36 
 b/debian/intel-microcode.default           |   15 
 b/debian/intel-microcode.dirs              |    2 
 b/debian/intel-microcode.lintian-overrides |    1 
 b/debian/intel-microcode.postinst          |   61 
 b/debian/intel-microcode.postrm            |   42 
 b/debian/rules                             |   76 
 b/debian/source/format                     |    2 
 b/debian/source/options                    |    1 
 b/microcode-20080220.dat                   |24374 ++++++++++++++++++++++
 b/microcode-20080401.dat                   |24693 ++++++++++++++++++++++
 b/microcode-20080910.dat                   |25849 +++++++++++++++++++++++
 b/microcode-20090330.dat                   |25910 +++++++++++++++++++++++
 b/microcode-20090927.dat                   |28154 +++++++++++++++++++++++++
 b/microcode-20100209.dat                   |30272 +++++++++++++++++++++++++++
 b/microcode-20100826.dat                   |31492 +++++++++++++++++++++++++++++
 b/microcode-20100914.dat                   |29950 +++++++++++++++++++++++++++
 b/microcode-20101123.dat                   |27048 ++++++++++++++++++++++++
 b/microcode-20110428.dat                   |27177 +++++++++++++++++++++++++
 b/microcode-20110915.dat                   |28973 ++++++++++++++++++++++++++
 b/microcode-20111110.dat                   |28971 ++++++++++++++++++++++++++
 b/microcode-20120606.dat                   |30317 +++++++++++++++++++++++++++
 debian/dirs                                |    1 
 debian/postinst                            |   47 
 microcode.dat                              |30317 ---------------------------
 36 files changed, 364068 insertions(+), 30446 deletions(-)


unblock intel-microcode/1.20120606.3

-- 
  "One disk to rule them all, One disk to find them. One disk to bring
  them all and in the darkness grind them. In the Land of Redmond
  where the shadows lie." -- The Silicon Valley Tarot
  Henrique Holschuh



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Release Team <debian-release@lists.debian.org>:
Bug#683674; Package release.debian.org. (Fri, 03 Aug 2012 00:48:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Henrique de Moraes Holschuh <hmh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Release Team <debian-release@lists.debian.org>. (Fri, 03 Aug 2012 00:48:05 GMT) Full text and rfc822 format available.

Message #10 received at 683674@bugs.debian.org (full text, mbox):

From: Henrique de Moraes Holschuh <hmh@debian.org>
To: 683674@bugs.debian.org
Subject: Changelogs for intel-microcode/1.20120606.3
Date: Thu, 2 Aug 2012 21:44:02 -0300
Changelogs since the version in Wheezy:

intel-microcode (1.20120606.3) unstable; urgency=low

   * initramfs: while creating the initramfs, if we need to iucode_tool
     --scan-system, attempt to modprobe cpuid if cpu/cpuid device is missing,
     and report an error if it doesn't work.  Thanks to Sebastian Andrzej
     Siewior for a good suggestion on how to fix it (closes: #683161)
   * README.Debian: add "modprobe cpuid" to example
   * debian/control: use better Vcs-browser URI that is properly
     handled by the current alioth redirector.

 -- Henrique de Moraes Holschuh <hmh@debian.org>  Sun, 29 Jul 2012 11:09:44 -0300

intel-microcode (1.20120606.2) unstable; urgency=low

   * Fix README.source to reflect that cpu-signatures.txt processing
     was moved to the toplevel Makefile
   * Update diff-latest-pack.sh to really find iucode_tool

 -- Henrique de Moraes Holschuh <hmh@debian.org>  Sat, 21 Jul 2012 18:10:47 -0300

intel-microcode (1.20120606.1) unstable; urgency=low

   * Change to ABI 1:
     + Ship binary microcode in /lib/firmware
     + Add initramfs helpers to install and load binary microcode on boot
     + Call update-initramfs on package upgrades and removals
     + Use non-deprecated kernel interface to interact with kernel
       (sysfs+fw loader)
   * Include microcode for older processors.  This should help some
     older boxes for which microcode was not being shipped by Intel
     anymore but which still have users, with the trade-off that we
     will also ship some useless and mostly useless microcode
   * Do not ship i686-only microcode in the amd64 binary package.  We
     still ship all microcode in the i386 binary package, to support
     64bit processors running i?86 userspace transparently
   * Switch myself to maintainer, and Giacomo to uploader to better
     reflect who is responsible for any bugs this could cause...
   * Switch to the 3.0 (native) package format as it doesn't make practical
     sense to base the source package on the Intel upstream tarball anymore
     because we use all past Intel microcode releases as source
     + Use xz to compress the tarball, it does a _much_ better job than
       bzip2 and gzip for this package
     + Override lintian warning about switch to native packaging, as it was
       done on purpose.  It can be removed in the future
   * Drop CDBS, switch to classic (less obfuscated/much better documented)
     debhelper build
   * Switch to debhelper v7, which is good enough for Debian Lenny and later
     don't use a newer mode for now, to facilitate backporting
   * Document in README.source:
     + this package must be trivial to backport to oldstable and stable
       (i.e. Debian Lenny and Debian Squeeze ATM)
     + how to add new upstream microcode packs and microcode overrides
     + other relevant details related to the lack of Intel changelogs
   * Build-Depend on iucode-tool to handle binary microcode, merge
     microcode packs and overrides, and split into firmware files
   * Drop support for microcode.ctl, as it cannot handle binary
     microcode or the non-deprecated kernel interface
   * Update package short and long descriptions
   * Add a NEWS file to explain all the behaviour changes
   * Recommend iucode-tool to support optional selective microcode
     selection for the initramfs (reduces microcode size greatly)
   * Change to priority: standard.  This package should be installed in
     every Intel-based Debian system, which is unfortunately impossible
     since it is non-free, but at least mark it as such
   * add debian/diff-latest-pack.sh utility (not shipped in the binary
     package) to help produce the "upstream changelogs"
   * debian/control: add Vcs-* fields

 -- Henrique de Moraes Holschuh <hmh@debian.org>  Fri, 13 Jul 2012 15:23:23 -0300 

-- 
  "One disk to rule them all, One disk to find them. One disk to bring
  them all and in the darkness grind them. In the Land of Redmond
  where the shadows lie." -- The Silicon Valley Tarot
  Henrique Holschuh



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Release Team <debian-release@lists.debian.org>:
Bug#683674; Package release.debian.org. (Sat, 01 Sep 2012 19:15:03 GMT) Full text and rfc822 format available.

Message #13 received at 683674@bugs.debian.org (full text, mbox):

From: Philipp Kern <pkern@debian.org>
To: Henrique de Moraes Holschuh <hmh@debian.org>, 683674@bugs.debian.org
Subject: Re: Bug#683674: unblock: intel-microcode/1.20120606.3
Date: Sat, 1 Sep 2012 21:10:59 +0200
[Message part 1 (text/plain, inline)]
Control: owner -1 !

On Thu, Aug 02, 2012 at 02:57:35PM -0300, Henrique de Moraes Holschuh wrote:
> Please unblock package intel-microcode

These are changes that are quite large. I'm willing to unblock them, though, as
they work much better / more reliable than microcode.ctl. The only thing left
to solve, from my point of view, is dropping the breaks on microcode.ctl and
the upload of a transitional package replacing it.

Just to update the status here, given that a private conversation with hmh
happened more or less accidentially.

Kind regards
Philipp Kern
[signature.asc (application/pgp-signature, inline)]

Owner recorded as Philipp Kern <pkern@debian.org>. Request was from Philipp Kern <pkern@debian.org> to 683674-submit@bugs.debian.org. (Sat, 01 Sep 2012 19:15:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Release Team <debian-release@lists.debian.org>, Philipp Kern <pkern@debian.org>:
Bug#683674; Package release.debian.org. (Tue, 04 Sep 2012 18:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Henrique de Moraes Holschuh <hmh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Release Team <debian-release@lists.debian.org>, Philipp Kern <pkern@debian.org>. (Tue, 04 Sep 2012 18:48:03 GMT) Full text and rfc822 format available.

Message #20 received at 683674@bugs.debian.org (full text, mbox):

From: Henrique de Moraes Holschuh <hmh@debian.org>
To: Philipp Kern <pkern@debian.org>
Cc: 683674@bugs.debian.org
Subject: Re: Bug#683674: unblock: intel-microcode/1.20120606.3
Date: Tue, 4 Sep 2012 15:44:45 -0300
On Sat, 01 Sep 2012, Philipp Kern wrote:
> On Thu, Aug 02, 2012 at 02:57:35PM -0300, Henrique de Moraes Holschuh wrote:
> > Please unblock package intel-microcode
> 
> These are changes that are quite large. I'm willing to unblock them, though, as
> they work much better / more reliable than microcode.ctl. The only thing left
> to solve, from my point of view, is dropping the breaks on microcode.ctl and
> the upload of a transitional package replacing it.

The transitional packages are ready, uploads are waiting for Giacomo's
permission.  If he doesn't answer in one week, I will upload to the delayed
queue.

-- 
  "One disk to rule them all, One disk to find them. One disk to bring
  them all and in the darkness grind them. In the Land of Redmond
  where the shadows lie." -- The Silicon Valley Tarot
  Henrique Holschuh



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Release Team <debian-release@lists.debian.org>, Philipp Kern <pkern@debian.org>:
Bug#683674; Package release.debian.org. (Sat, 08 Sep 2012 12:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Henrique de Moraes Holschuh <hmh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Release Team <debian-release@lists.debian.org>, Philipp Kern <pkern@debian.org>. (Sat, 08 Sep 2012 12:51:03 GMT) Full text and rfc822 format available.

Message #25 received at 683674@bugs.debian.org (full text, mbox):

From: Henrique de Moraes Holschuh <hmh@debian.org>
To: Philipp Kern <pkern@debian.org>
Cc: 683674@bugs.debian.org
Subject: Re: Bug#683674: unblock: intel-microcode/1.20120606.3
Date: Sat, 8 Sep 2012 09:48:40 -0300
Transitional packages were uploaded yesterday, and are in the DELAYED/2
queue ATM:

intel-microcode 1.20120606.6    Conflicts: microcode.ctl (<< 1.18~0)

microcode.ctl   1.18~0+nmu1     Depends: intel-microcode (>> 1), iucode-tool
                                Conflicts: intel-microcode (<< 1)

-- 
  "One disk to rule them all, One disk to find them. One disk to bring
  them all and in the darkness grind them. In the Land of Redmond
  where the shadows lie." -- The Silicon Valley Tarot
  Henrique Holschuh



Changed Bug title to 'unblock: intel-microcode/1.20120606.6' from 'unblock: intel-microcode/1.20120606.3' Request was from Henrique de Moraes Holschuh <hmh@debian.org> to control@bugs.debian.org. (Thu, 13 Sep 2012 21:24:21 GMT) Full text and rfc822 format available.

Added blocking bug(s) of 683674: 687835 Request was from Henrique de Moraes Holschuh <hmh@debian.org> to control@bugs.debian.org. (Sun, 16 Sep 2012 14:24:03 GMT) Full text and rfc822 format available.

Reply sent to Philipp Kern <pkern@debian.org>:
You have taken responsibility. (Wed, 19 Sep 2012 12:15:07 GMT) Full text and rfc822 format available.

Notification sent to Henrique de Moraes Holschuh <hmh@debian.org>:
Bug acknowledged by developer. (Wed, 19 Sep 2012 12:15:07 GMT) Full text and rfc822 format available.

Message #34 received at 683674-done@bugs.debian.org (full text, mbox):

From: Philipp Kern <pkern@debian.org>
To: Henrique de Moraes Holschuh <hmh@debian.org>, 683674-done@bugs.debian.org
Subject: Re: Bug#683674: unblock: intel-microcode/1.20120606.3
Date: Wed, 19 Sep 2012 14:11:12 +0200
[Message part 1 (text/plain, inline)]
On Sat, Sep 08, 2012 at 09:48:40AM -0300, Henrique de Moraes Holschuh wrote:
> Transitional packages were uploaded yesterday, and are in the DELAYED/2
> queue ATM:
> 
> intel-microcode 1.20120606.6    Conflicts: microcode.ctl (<< 1.18~0)
> 
> microcode.ctl   1.18~0+nmu1     Depends: intel-microcode (>> 1), iucode-tool
>                                 Conflicts: intel-microcode (<< 1)

Both unblocked, thanks.

Kind regards
Philipp Kern 
[signature.asc (application/pgp-signature, inline)]

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 18 Oct 2012 07:27:17 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 00:57:19 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.